"use strict";
(self["webpackChunkjupyterlab_jupyterbook_navigation"] = self["webpackChunkjupyterlab_jupyterbook_navigation"] || []).push([["lib_index_js-lib_jbtoc_js"],{

/***/ "./lib/index.js":
/*!**********************!*\
  !*** ./lib/index.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   getJupyterAppInstance: () => (/* binding */ getJupyterAppInstance)
/* harmony export */ });
/* harmony import */ var _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/application */ "webpack/sharing/consume/default/@jupyterlab/application");
/* harmony import */ var _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/docmanager */ "webpack/sharing/consume/default/@jupyterlab/docmanager");
/* harmony import */ var _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/filebrowser */ "webpack/sharing/consume/default/@jupyterlab/filebrowser");
/* harmony import */ var _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jbtoc__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./jbtoc */ "./lib/jbtoc.js");





let appInstance = null;
function getJupyterAppInstance(app) {
    if (!appInstance && app) {
        appInstance = app;
    }
    if (!appInstance) {
        throw new Error("App instance has not been initialized yet");
    }
    return appInstance;
}
const plugin = {
    id: 'jupyterlab-jupyterbook-navigation:plugin',
    description: 'A JupyterLab extension that mimics jupyter-book chapter navigation on an un-built, cloned jupyter book in JupyterLab.',
    autoStart: true,
    requires: [_jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__.ILabShell, _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_3__.IFileBrowserFactory, _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2__.IDocumentManager],
    activate: async (app, shell, fileBrowserFactory, docManager) => {
        getJupyterAppInstance(app);
        console.log('JupyterLab extension jupyterlab-jupyterbook-navigation is activated!');
        const widget = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__.Widget();
        widget.id = '@jupyterlab-sidepanel/jupyterbook-toc';
        widget.title.iconClass = 'jbook-icon jp-SideBar-tabIcon';
        widget.title.className = 'jbook-tab';
        widget.title.caption = 'Jupyter-Book Table of Contents';
        const summary = document.createElement('p');
        widget.node.appendChild(summary);
        widget.activate = async () => {
            const fileBrowser = fileBrowserFactory.tracker.currentWidget;
            if (!fileBrowser) {
                console.debug('File browser widget is null.');
            }
            else {
                console.debug('Active file browser widget found.');
            }
            try {
                const cwd = fileBrowser === null || fileBrowser === void 0 ? void 0 : fileBrowser.model.path;
                if (typeof cwd === 'string') {
                    const toc = await _jbtoc__WEBPACK_IMPORTED_MODULE_4__.getTOC(cwd);
                    summary.innerHTML = toc;
                }
                addClickListenerToButtons(fileBrowser, docManager);
                addClickListenerToChevron();
            }
            catch (reason) {
                console.error(`The jupyterlab_jupyterbook_navigation error: ${reason}`);
            }
        };
        shell.add(widget, 'left', { rank: 400 });
        widget.activate();
    }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (plugin);
function addClickListenerToChevron() {
    const buttons = document.querySelectorAll('.toc-chevron');
    buttons.forEach(buttonElement => {
        const button = buttonElement;
        button.addEventListener('click', (event) => {
            console.log('Button clicked');
            toggleList(button);
        });
    });
}
function toggleList(button) {
    var _a;
    const list = (_a = button.parentElement) === null || _a === void 0 ? void 0 : _a.nextElementSibling;
    if (list.style.display === 'none') {
        list.style.display = 'block';
        button.innerHTML = '<i class="fa fa-chevron-up toc-chevron"></i>';
    }
    else {
        list.style.display = 'none';
        button.innerHTML = '<i class="fa fa-chevron-down toc-chevron"></i>';
    }
}
function addClickListenerToButtons(fileBrowser, docManager) {
    const buttons = document.querySelectorAll('.toc-button');
    buttons.forEach(button => {
        button.addEventListener('click', (event) => {
            console.log('Button clicked');
            if (!fileBrowser) {
                console.error('File browser not found');
                return;
            }
            const toc_div = button.closest('.jbook-toc');
            if (!toc_div) {
                console.error('jbook-toc div not found');
                return;
            }
            const toc_dir = toc_div.getAttribute('data-toc-dir');
            if (typeof toc_dir !== 'string') {
                console.error('data-toc-dir attribute loaded');
                return;
            }
            if (typeof fileBrowser.model.path !== 'string') {
                console.error(`Invalid path: The current path is either not set or not a string. Path: ${fileBrowser.model.path}`);
                return;
            }
            console.log(`Current directory: ${fileBrowser.model.path}`);
            const filePath = button.getAttribute('data-file-path');
            if (typeof filePath === 'string') {
                if (filePath.includes('.md')) {
                    docManager.openOrReveal(filePath, 'Markdown Preview');
                }
                else {
                    docManager.openOrReveal(filePath);
                }
            }
        });
    });
}


/***/ }),

/***/ "./lib/jbtoc.js":
/*!**********************!*\
  !*** ./lib/jbtoc.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getTOC: () => (/* binding */ getTOC)
/* harmony export */ });
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! path */ "./node_modules/path-browserify/index.js");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var js_yaml__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! js-yaml */ "webpack/sharing/consume/default/js-yaml/js-yaml");
/* harmony import */ var js_yaml__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(js_yaml__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _index__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./index */ "./lib/index.js");



async function getFileContents(path) {
    try {
        const app = (0,_index__WEBPACK_IMPORTED_MODULE_2__.getJupyterAppInstance)();
        const data = await app.serviceManager.contents.get(path, { content: true });
        if (data.type === 'notebook' || data.type === 'file') {
            return data.content;
        }
        else {
            throw new Error(`Unsupported file type: ${data.type}`);
        }
    }
    catch (error) {
        console.error(`Failed to get file contents for ${path}:`, error);
        throw error;
    }
}
function isNotebook(obj) {
    return obj && typeof obj === 'object' && Array.isArray(obj.cells);
}
async function getTitle(filePath) {
    const suffix = path__WEBPACK_IMPORTED_MODULE_0__.extname(filePath);
    if (suffix === '.ipynb') {
        try {
            const jsonData = await getFileContents(filePath);
            if (isNotebook(jsonData)) {
                const firstHeaderCell = jsonData.cells.find(cell => cell.cell_type === 'markdown');
                if (firstHeaderCell) {
                    if (firstHeaderCell.source.split('\n')[0].slice(0, 2) === '# ') {
                        const title = firstHeaderCell.source
                            .split('\n')[0]
                            .slice(2);
                        return title;
                    }
                }
            }
        }
        catch (error) {
            console.error('Error reading or parsing notebook:', error);
        }
    }
    else if (suffix === '.md') {
        try {
            const md = await getFileContents(filePath);
            if (!isNotebook(md)) {
                const lines = md.split('\n');
                for (const line of lines) {
                    if (line.slice(0, 2) === '# ') {
                        return line.slice(2);
                    }
                }
            }
        }
        catch (error) {
            console.error('Error reading or parsing Markdown:', error);
        }
    }
    return null;
}
function isIJbookConfig(obj) {
    return obj && typeof obj === 'object' && obj.title && obj.author;
}
async function getBookConfig(configPath) {
    try {
        const yamlStr = await getFileContents(configPath);
        if (typeof yamlStr === 'string') {
            const config = js_yaml__WEBPACK_IMPORTED_MODULE_1__.load(yamlStr);
            if (isIJbookConfig(config)) {
                const title = config.title || 'Untitled Jupyter Book';
                const author = config.author || 'Anonymous';
                return { title, author };
            }
            else {
                console.error('Error: Misconfigured Jupyter Book config.');
            }
        }
    }
    catch (error) {
        console.error('Error reading or parsing config:', error);
    }
    return { title: null, author: null };
}
async function ls(pth) {
    if (pth === "") {
        pth = "/";
    }
    try {
        const app = (0,_index__WEBPACK_IMPORTED_MODULE_2__.getJupyterAppInstance)();
        const data = await app.serviceManager.contents.get(pth, { content: true });
        return data;
    }
    catch (error) {
        console.error("Error listing directory contents:", error);
        return null;
    }
}
async function globFiles(pattern) {
    const baseDir = '';
    const result = [];
    try {
        const app = (0,_index__WEBPACK_IMPORTED_MODULE_2__.getJupyterAppInstance)();
        const data = await app.serviceManager.contents.get(baseDir, { content: true });
        const regex = new RegExp(pattern);
        for (const item of data.content) {
            if (item.type === 'file' && regex.test(item.path)) {
                result.push(item.path);
            }
        }
    }
    catch (error) {
        console.error(`Error globbing pattern ${pattern}`, error);
    }
    return result;
}
async function findTOCinParents(cwd) {
    const dirs = cwd.split('/');
    const tocPattern = '_toc.yml';
    let counter = 0;
    while (counter < 1) {
        const pth = dirs.join('/');
        const files = await ls(pth);
        for (const value of Object.values(files.content)) {
            const file = value;
            if (file.path.includes(tocPattern)) {
                return file.path;
            }
        }
        if (dirs.length == 0) {
            counter += 1;
        }
        else {
            dirs.pop();
        }
    }
    return null;
}
async function getFullPath(file_pattern, dir_pth) {
    const files = await ls(dir_pth);
    for (const value of Object.values(files.content)) {
        const file = value;
        if (file.path.includes(file_pattern)) {
            return file.path;
        }
    }
    return `Unable to locate ${file_pattern} in ${dir_pth}`;
}
async function getSubSection(parts, cwd, level = 1, html = '') {
    if (cwd && cwd.slice(-1) !== '/') {
        cwd = cwd + '/';
    }
    async function insert_one_file(file) {
        const parts = file.split('/');
        parts.pop();
        const k_dir = parts.join('/');
        const pth = await getFullPath(file, `${cwd}${k_dir}`);
        let title = await getTitle(pth);
        if (!title) {
            title = file;
        }
        html += `<button class="jp-Button toc-button tb-level${level}" style="display: block;" data-file-path="${pth}">${title}</button>`;
    }
    for (const k of parts) {
        if (k.sections && k.file) {
            const parts = k.file.split('/');
            parts.pop();
            const k_dir = parts.join('/');
            const pth = await getFullPath(k.file, `${cwd}${k_dir}`);
            let title = await getTitle(pth);
            if (!title) {
                title = k.file;
            }
            html += `
        <div>
            <button class="jp-Button toc-button tb-level${level}"style="display: inline-block;" data-file-path="${pth}">${title}</button>
            <button class="jp-Button toc-chevron" style="display: inline-block;"><i class="fa fa-chevron-down "></i></button>
        </div>
        <div style="display: none;">
        `;
            const html_cur = html;
            html = await getSubSection(k.sections, cwd, (level = level + 1), (html = html_cur));
            html += '</div>';
        }
        else if (k.file) {
            await insert_one_file(k.file);
        }
        else if (k.url) {
            html += `<button class="jp-Button toc-button tb-level${level}" style="display:block;"><a class="toc-link tb-level${level}" href="${k.url}" target="_blank" rel="noopener noreferrer" style="display: block;">${k.title}</a></button>`;
        }
        else if (k.glob) {
            const files = await globFiles(`${cwd}${k.glob}`);
            for (const file of files) {
                const relative = file.replace(`${cwd}`, '');
                await insert_one_file(relative);
            }
        }
    }
    return html;
}
async function tocToHtml(toc, cwd) {
    let html = '\n<ul>';
    if (toc.parts) {
        for (const chapter of toc.parts) {
            html += `\n<p class="caption" role="heading"><span class="caption-text"><b>\n${chapter.caption}\n</b></span>\n</p>`;
            const subISectionHtml = await getSubSection(chapter.chapters, cwd);
            html += `\n${subISectionHtml}`;
        }
    }
    else {
        if (toc.chapters) {
            const subISectionHtml = await getSubSection(toc.chapters, cwd);
            html += `\n${subISectionHtml}`;
        }
    }
    html += '\n</ul>';
    return html;
}
async function getTOC(cwd) {
    const tocPath = await findTOCinParents(cwd);
    let configPath = null;
    let configParent = null;
    if (tocPath) {
        const parts = tocPath.split('/');
        parts.pop();
        configParent = parts.join('/');
        const files = await ls(configParent);
        const configPattern = '_config.yml';
        for (const value of Object.values(files.content)) {
            const file = value;
            if (file.path.includes(configPattern)) {
                configPath = file.path;
                break;
            }
        }
    }
    if (tocPath &&
        configParent !== null &&
        configParent !== undefined &&
        configPath) {
        try {
            const tocYamlStr = await getFileContents(tocPath);
            if (typeof tocYamlStr === 'string') {
                const tocYaml = js_yaml__WEBPACK_IMPORTED_MODULE_1__.load(tocYamlStr);
                const toc = tocYaml;
                const config = await getBookConfig(configPath);
                const toc_html = await tocToHtml(toc, configParent);
                return `
          <div class="jbook-toc" data-toc-dir="${configParent}"><p id="toc-title">${config.title}</p>
          <p id="toc-author">Author: ${config.author}</p>
          ${toc_html} </div>
            `;
            }
            else {
                console.error('Error: Misconfigured Jupyter Book _toc.yml.');
            }
        }
        catch (error) {
            console.error('Error reading or parsing _toc.yml:', error);
        }
    }
    return `
    <p id="toc-title">Not a Jupyter-Book</p>
    <p id="toc-author">"_toc.yml" and/or "_config.yml" not found in or above:</p>
    <p id="toc-author">${cwd}</p>
    <p id="toc-author">Please navigate to a directory containing a Jupyter-Book to view its Table of Contents</p>
    `;
}


/***/ })

}]);
//# sourceMappingURL=lib_index_js-lib_jbtoc_js.15e53cb4a3c93cad2a2e.js.map